de.caff.generics.function

## Interface VarCharOperator

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface VarCharOperator

  Primitive char operator with a variable number of arguments.

  Although this basically works for a variable char array via the `apply(char...)` method implementors have to implement the method `apply(CharIndexable)` with a `CharIndexable` argument. This is done to make this class generally more useful without the need to copy arrays.

  Since:
    November 03, 2020
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default char` | `apply(char... values)` Apply this operator.
    `char` | `apply(CharIndexable values)` Apply this operator.
    `static VarCharOperator` | `fromBinary(CharOperator2 binaryOp, char startValue)` Create an variable args operator from applying a binary operator over and over.

- - ### Method Detail

    - #### apply

          default char apply(char... values)

      Apply this operator. This default method forwards execution to `apply(CharIndexable)`.
      Parameters:
        `values` - arguments on which this operator is applied
      Returns:
        result of applying this operator to all arguments

    - #### apply

          char apply(@NotNull
                     CharIndexable values)

      Apply this operator.
      Parameters:
        `values` - indexable providing the values on which this operator operates
      Returns:
        result of applying this operator to all values

    - #### fromBinary

          @NotNull
          static VarCharOperator fromBinary(@NotNull
                                                     CharOperator2 binaryOp,
                                                     char startValue)

      Create an variable args operator from applying a binary operator over and over.

      Eg

           VarCharOperator maxOp = VarCharOperator.fromBinary((v1, v2) -> (char)Math.max(v1, v2), '\0');
           char max = maxOp.apply('A', 'B', 'C', 'D'');

      On each application the currently accumulated result becomes the left (first) argument of `binaryOp`, while the run value becomes the right (second).
      Parameters:
        `binaryOp` - binary operator
        `startValue` - start value (result of operator if no values are given)
      Returns:
        variable char argument operator which applies the given binary operator over and over